
// insert a char at row,col on the top line of PI
// chars to the right move over.

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <editline.h>

#define MAXLN 250
#define COLMAX 85

void insertChar(c,Col,p) 
int c;   // char to insert
int Col; // 0..COLMAX (COLMAX=79 for a default terminal). Assume < MAXLN-1
char *p; // a string buffer, null terminated
{
char buf[MAXLN+1];
char ch[2]={c,0};

  // c &= 255;                     /* strip to 8 bits */
  if(c==0) c=128;               /* can't put NULL into strings */
  int i=strlen(p); 
  if(Col>=i) { // then blank fill the string to that column
    while(i < MAXLN && i++ < Col) strcat(p," "); 
  }
  if(i >= MAXLN-1){puts("Exceeded string length"); exit(0);}
      /* tried to extend line too far */
      /* WRDWRP margin is at most MAXLN-2 */
  strcpy(buf,p);
  buf[Col]=c; // insert char
  strcpy(buf+Col+1,p+Col); // buf now has the altered string
  strcpy(p,buf);

}

int main(argc,argv) int argc; char **argv;
{
char q[MAXLN];
char *p;

while(1){
  p=readline("Enter q: ");
  strcpy(q,p); 
  printf("Inserting c='X' into q at char 10\r\n");
  insertChar('X',10,q);
  printf("q=|%s| and after insert\r\nq=|%s|\r\n",p,q);
  free(p);
}

}
