#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <time.h> 
  
time_t starttime=0;
  
void timer_callback(int signum)
{
    time_t now = time(NULL);
    time_t elapsed=now-starttime;
    printf("Signal %d caught at time=%li seconds since Epoch\r\n", signum, now);
    printf("Elapsed time in seconds = %li\r\n",elapsed);
}
 
int main()
{
    time_t start=time(&starttime);
    signal(SIGALRM, timer_callback);
    alarm(1);
    printf("Sleep 3 seconds\r\n");
    sleep(3);
    return 0;
}
